/*
	AsciiToFloatCmd.h - convert f.p numbers in text format to floating point

	Will Eighteen, 2005: will@opaline.demon.co.uk
*/

#ifndef ASCIITOFLOATCMD_H
#define ASCIITOFLOATCMD_H

#ifndef BREAK
#define BREAK
#include <BreakCmd.h>
#endif


#define BUFSIZE 1024


class FileAccess;


class AsciiToFloatCmd : public BreakCmd
{
	public:
		AsciiToFloatCmd ( char *, int, char *, char * );
		virtual ~AsciiToFloatCmd();
		char *source() { return _srcFile; };
		char *target() { return _dstFile; };
		int error() { return _error; }
		void offset ( float num ) { _offset = num; }
		void scale ( float num ) { _scale = num; }

	protected:
		void doCommand();
		
	private:
		char _srcFile[BUFSIZE];
		char _dstFile[BUFSIZE];
		FileAccess *_in;
		FileAccess *_out;
		int _once, _percentDone, _error;
		float _fValue, _offset, _scale;
};

#endif
