/*
    NewSpatialTemplateCmd.h - make new CSound '.sco' file for spatial_template.orc

    Will 18, 2001, 2006: will@opaline.demon.co.uk
*/

#ifndef NEWSPATIALTEMPLATECMD_H
#define NEWSPATIALTEMPLATECMD_H

#include <NoUndoCmd.h>
#include "GraphFltCmd.h"


#ifndef BREAK
#define BREAK
#include <BreakCmd.h>
#endif

#define BUFSIZE 1024


class DMenuCmd;
class CreateSpatialTemplateCmd;
class CreateTemplateFileCmd;
class FileAccess;


struct SpatialPak {
					char name[1024];	/* base name for data files */

					GraphFltCmd *rvbView;
					float *rvbArray;
					long rvbStartRange;
					long rvbEndRange;
					long rvbStartSel;
					long rvbEndSel;
					long rvbXCurrent;
					float rvbYCurrent;
					long rvbFilePos;
					long rvbArraySize;	// num data items
					long rvbDataOffset;
					long rvbDataSize;
					unsigned int rvbGraphNum;
					float rvbMin;
					float rvbMax;
					int rvbFLock;
					FileAccess *rvbFile;

					GraphFltCmd *rangeView;
					float *rangeArray;
					long rangeStartRange;
					long rangeEndRange;
					long rangeStartSel;
					long rangeEndSel;
					long rangeXCurrent;
					float rangeYCurrent;
					long rangeFilePos;
					long rangeArraySize;
					long rangeDataOffset;
					long rangeDataSize;
					unsigned int rangeGraphNum;
					float rangeMin;
					float rangeMax;
					int rangeFLock;
					FileAccess *rangeFile;

					GraphFltCmd *bwView;
					float *bwArray;
					long bwStartRange;
					long bwEndRange;
					long bwStartSel;
					long bwEndSel;
					long bwXCurrent;
					float bwYCurrent;
					long bwFilePos;
					long bwArraySize;
					long bwDataOffset;
					long bwDataSize;
					unsigned int bwGraphNum;
					float bwMin;
					float bwMax;
					int bwFLock;
					FileAccess *bwFile;

					GraphFltCmd *sweepView;
					float *sweepArray;
					long sweepStartRange;
					long sweepEndRange;
					long sweepStartSel;
					long sweepEndSel;
					long sweepXCurrent;
					float sweepYCurrent;
					long sweepFilePos;
					long sweepArraySize;
					long sweepDataOffset;
					long sweepDataSize;
					unsigned int sweepGraphNum;
					float sweepMin;
					float sweepMax;
					int sweepFLock;
					FileAccess *sweepFile;

					GraphFltCmd *panView;
					float *panArray;
					long panStartRange;
					long panEndRange;
					long panStartSel;
					long panEndSel;
					long panXCurrent;
					float panYCurrent;
					long panFilePos;
					long panArraySize;
					long panDataOffset;
					long panDataSize;
					unsigned int panGraphNum;
					float panMin;
					float panMax;
					int panFLock;
					FileAccess *panFile;

					GraphFltCmd *dopplerView;
					float *dopplerArray;
					long dopplerStartRange;
					long dopplerEndRange;			
					long dopplerStartSel;
					long dopplerEndSel;
					long dopplerXCurrent;
					float dopplerYCurrent;
					long dopplerFilePos;
					long dopplerArraySize;
					long dopplerDataOffset;
					long dopplerDataSize;
					unsigned int dopplerGraphNum;
					float dopplerMin;
					float dopplerMax;
					int dopplerFLock;
					FileAccess *dopplerFile;

					unsigned panType;
					unsigned filterType;
					float angularSep;
					float signalScale;
					float detune;
					unsigned phaser;	// 0 = off, 1 = 0n
					float rvbTailTime;

					GraphFltCmd *rvbLView;
					float *rvbLArray;
					long rvbLStartRange;
					long rvbLEndRange;
					long rvbLStartSel;
					long rvbLEndSel;
					long rvbLXCurrent;
					float rvbLYCurrent;
					long rvbLFilePos;
					long rvbLArraySize;
					long rvbLDataOffset;
					long rvbLDataSize;
					unsigned int rvbLGraphNum;
					float rvbLMin;
					float rvbLMax;
					int rvbLFLock;
					FileAccess *rvbLFile;

					GraphFltCmd *rvbRView;
					float *rvbRArray;
					long rvbRStartRange;
					long rvbREndRange;
					long rvbRStartSel;
					long rvbREndSel;
					long rvbRXCurrent;
					float rvbRYCurrent;
					long rvbRFilePos;
					long rvbRArraySize;
					long rvbRDataOffset;
					long rvbRDataSize;
					unsigned int rvbRGraphNum;
					float rvbRMin;
					float rvbRMax;
					int rvbRFLock;
					FileAccess *rvbRFile;

					GraphFltCmd *panLView;
					float *panLArray;
					long panLStartRange;
					long panLEndRange;
					long panLStartSel;
					long panLEndSel;
					long panLXCurrent;
					float panLYCurrent;
					long panLFilePos;
					long panLArraySize;
					long panLDataOffset;
					long panLDataSize;
					unsigned int panLGraphNum;
					float panLMin;
					float panLMax;
					int panLFLock;
					FileAccess *panLFile;

					GraphFltCmd *panRView;
					float *panRArray;
					long panRStartRange;
					long panREndRange;
					long panRStartSel;
					long panREndSel;
					long panRXCurrent;
					float panRYCurrent;
					long panRFilePos;
					long panRArraySize;
					long panRDataOffset;
					long panRDataSize;
					unsigned int panRGraphNum;
					float panRMin;
					float panRMax;
					int panRFLock;
					FileAccess *panRFile;

					unsigned panLType;
					unsigned panRType;

					GraphFltCmd *bwLView;
					float *bwLArray;
					long bwLStartRange;
					long bwLEndRange;
					long bwLStartSel;
					long bwLEndSel;
					long bwLXCurrent;
					float bwLYCurrent;
					long bwLFilePos;
					long bwLArraySize;
					long bwLDataOffset;
					long bwLDataSize;
					unsigned int bwLGraphNum;
					float bwLMin;
					float bwLMax;
					int bwLFLock;
					FileAccess *bwLFile;

					GraphFltCmd *bwRView;
					float *bwRArray;
					long bwRStartRange;
					long bwREndRange;
					long bwRStartSel;
					long bwREndSel;
					long bwRXCurrent;
					float bwRYCurrent;
					long bwRFilePos;
					long bwRArraySize;
					long bwRDataOffset;
					long bwRDataSize;
					unsigned int bwRGraphNum;
					float bwRMin;
					float bwRMax;
					int bwRFLock;
					FileAccess *bwRFile;

					GraphFltCmd *sweepLView;
					float *sweepLArray;
					long sweepLStartRange;
					long sweepLEndRange;
					long sweepLStartSel;
					long sweepLEndSel;
					long sweepLXCurrent;
					float sweepLYCurrent;
					long sweepLFilePos;
					long sweepLArraySize;
					long sweepLDataOffset;
					long sweepLDataSize;
					unsigned int sweepLGraphNum;
					float sweepLMin;
					float sweepLMax;
					int sweepLFLock;
					FileAccess *sweepLFile;

					GraphFltCmd *sweepRView;
					float *sweepRArray;
					long sweepRStartRange;
					long sweepREndRange;
					long sweepRStartSel;
					long sweepREndSel;
					long sweepRXCurrent;
					float sweepRYCurrent;
					long sweepRFilePos;
					long sweepRArraySize;
					long sweepRDataOffset;
					long sweepRDataSize;
					unsigned int sweepRGraphNum;
					float sweepRMin;
					float sweepRMax;
					int sweepRFLock;
					FileAccess *sweepRFile;

					float delayL;
					float delayR;

					GraphFltCmd *ampLView;
					float *ampLArray;
					long ampLStartRange;
					long ampLEndRange;
					long ampLStartSel;
					long ampLEndSel;
					long ampLXCurrent;
					float ampLYCurrent;
					long ampLFilePos;
					long ampLArraySize;
					long ampLDataOffset;
					long ampLDataSize;
					unsigned int ampLGraphNum;
					float ampLMin;
					float ampLMax;
					int ampLFLock;
					FileAccess *ampLFile;
					GraphFltCmd *ampRView;

					float *ampRArray;
					long ampRStartRange;
					long ampREndRange;
					long ampRStartSel;
					long ampREndSel;
					long ampRXCurrent;
					float ampRYCurrent;
					long ampRFilePos;
					long ampRArraySize;
					long ampRDataOffset;
					long ampRDataSize;
					unsigned int ampRGraphNum;
					float ampRMin;
					float ampRMax;
					int ampRFLock;
					FileAccess *ampRFile;

					unsigned filterLType;
					unsigned filterRType;
				};


typedef void ( *NewSpatialTemplateCallback ) ( void *, char *, unsigned int );


class NewSpatialTemplateCmd : public NoUndoCmd
{
	protected:
		void doCommand();	// NewSpatialTemplate
		NewSpatialTemplateCallback _callback;
		void * _clientData;
		char * _name;

	public:
		NewSpatialTemplateCmd ( char *, int, NewSpatialTemplateCallback, void * );
		NewSpatialTemplateCmd ( char *, int );
		virtual const char *const className() { return ( "NewSpatialTemplateCmd" ); }

	private:
		static void spatialTemplateCreatedCallback ( CreateSpatialTemplateCmd *, void *, unsigned int );
		static void menuSelectionCallback ( void *, unsigned int, char * );

		// overwrite dialog callbacks
		static void overwriteOkCallback ( void * );
		static void overwriteCancelCallback ( void * );

		// template callbacks and functions
		static void checkReverbTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkReverbTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkReverbTemplateFile ( void );

		static void checkRangeTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkRangeTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkRangeTemplateFile ( void );

		static void checkBwidthTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkBwidthTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkBwidthTemplateFile ( void );

		static void checkSweepTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkSweepTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkSweepTemplateFile ( void );

		static void checkPanTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkPanTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkPanTemplateFile ( void );

		static void checkDopplerTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkDopplerTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkDopplerTemplateFile ( void );

		static void checkReverbLTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkReverbLTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkReverbLTemplateFile ( void );

		static void checkReverbRTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkReverbRTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkReverbRTemplateFile ( void );

		static void checkPanLTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkPanLTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkPanLTemplateFile ( void );

		static void checkPanRTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkPanRTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkPanRTemplateFile ( void );

		static void checkBwidthLTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkBwidthLTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkBwidthLTemplateFile ( void );

		static void checkBwidthRTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkBwidthRTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkBwidthRTemplateFile ( void );

		static void checkSweepLTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkSweepLTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkSweepLTemplateFile ( void );

		static void checkSweepRTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkSweepRTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkSweepRTemplateFile ( void );

		static void checkAmpLTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkAmpLTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkAmpLTemplateFile ( void );

		static void checkAmpRTemplateFinishedCallback ( BreakCmd *, Boolean, void * );
		void checkAmpRTemplateFinished ( CreateTemplateFileCmd *, char * );
		void checkAmpRTemplateFile ( void );

		void overwriteCancelled ( void );
		void checkSpatialPakFile ( void );
		void waveSelected ( char *, unsigned int );
		void waveSelected ( void );
		void spatialTemplateCreated ( unsigned int );
		void pakInitialise();

		char _pakData[BUFSIZE];
		char _baseName[BUFSIZE];
		char _error[1024];
		DMenuCmd *_menu;
		Boolean _menuRealised;
		unsigned int _arrayItems;
		unsigned int _waveNum;
		unsigned int _callbackReason;
		int _defaultTemplateSize;
		SpatialPak *_spatialPak;
};


#endif
