// MessageTestWindow.cc

#include "MessageTestWindow.h"
#include <MessageDialogManager.h>
#include <Xm/PushB.h>

#include <stdio.h> // debug

void postDialogCallback ( Widget, XtPointer, XtPointer );
void okCallback ( void * );
void cancelCallback ( void *data );

Widget MessageTestWindow::createWorkArea ( Widget parent )
{
	Widget button = XtCreateManagedWidget ( "push_to_test",
											xmPushButtonWidgetClass,
											parent, NULL, 0 );

	XtAddCallback ( button, XmNactivateCallback, postDialogCallback, NULL );
	return ( button );
}

void postDialogCallback ( Widget, XtPointer, XtPointer )
{
	messageDialogManager->post ( "Message String\nok", ( void *
) NULL,
								 okCallback, cancelCallback );
}

void okCallback ( void * )
{
	cout << "Ok\n" << flush;
}

void cancelCallback ( void * )
{
	cout << "Cancel\n" << flush;
}

